/* WARNING!!! I'm not sure if all C includes for mrq.library v1.12 */
/* are error free!!! I'm still working on it. Be careful!          */

#ifndef LIBRARIES_MISTERQ_H
#define LIBRARIES_MISTERQ_H 1

#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef DOS_DOS_H
#include <dos/dos.h>
#endif

#ifndef GRAPHICS_GFX_H
#include <graphics/gfx.h>
#endif

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif

#ifndef LIBRARIES_REQTOOLS_H
#include <libraries/reqtools.h>
#endif

#define DOSLIB_ERROR  0x01
#define GFXLIB_ERROR  0x02
#define REQLIB_ERROR  0x04
#define INTLIB_ERROR  0x08
#define ASLLIB_ERROR  0x10
#define CYBERLIB_EROR 0x20

#define AGA_DISPLAY   0xf000
#define CGX_DISPLAY   0xff00

struct MisterQBase
{
   struct DosLibrary *DOSBase;               // adresy bazowe otwartych bibliotek
   struct GfxBase *GfxBase;
   struct IntuitionBase *IntuitionBase;
   struct ReqToolsBase *ReqToolsBase;
   struct Library *AslBase;
   struct Library *CyberGfxBase;

   LONG _szer;                           // szeroko ekranu
   LONG _wys;                            // wysoko ekranu
   LONG chmaxx;                          // szeroko okna wywietlania
   LONG chmaxy;                          // wysoko okna wywietlania
   UWORD ChunkyMode;                     // tryb pracy C2P w zalenoi od koci GFX (AGA_DISPLAY,CGX_DISPLAY)
   struct RastPort *s_RastPort;          // rastport ekranu otwartego za pomoc MOpenScreen()
   struct Screen *WB_Base;               // adres struktury Screen ekranu WB. Pole wypenia procedura MOpenScreen()
   struct ViewPort *WB_ViewPort;         // adres struktury ViewPort ekranu WB. Pole wypenia procedura MOpenScreen()
   struct Screen *s_ScreenBase;          // adres struktury Screen ostatnio otwartego ekranu. Pole wypenia procedura MOpenScreen()

   PLANEPTR _bitplan0;                   // wskaniki na bitplany otwartego ekranu.
   PLANEPTR _bitplan1;                   // Pola wypenia procedura MOpenScreen()
   PLANEPTR _bitplan2;           
   PLANEPTR _bitplan3;           
   PLANEPTR _bitplan4;           
   PLANEPTR _bitplan5;           
   PLANEPTR _bitplan6;           
   PLANEPTR _bitplan7;           

   LONG LibraryError;                  // ktra z otwieranych bibliotek przez MisterQInit() si nie otwara.
   LONG BestModeTags;                  // !private!   Pole wypenia procedura MOpenScreen()
   LONG ScreenTags;                    // !private! (Tagi otwieranego ekranu)  Pole wypenia procedura MOpenScreen()
   struct BitMap *BitMapSTR;           // adres struktury Bitmap ostatnio otwartego ekranu. Pole wypenia procedura MOpenScreen()
   struct FileRequest *FileRequest;    // adres struktury FileRequest ostatnio otwartego requestera do wyboru plikw                                                

   STRPTR _FileName;                   // adres acucha tekstowego - nazwy pliku
   STRPTR _DirName;                    // adres acucha tekstowego - nazwy katalogu
   STRPTR _Path;                       // adres acucha tekstowego - penej cieki dostpu wraz z plikiem

   LONG _FileSize;                     // dugo ostatnio wczytanego pliku
   APTR _FileAddr;                     // adres ostatnio wczytanego pliku
   STRPTR tabdec1;                     // adres cigu ASCII liczby dziesitnej z zerami - zakres +/- 2 miliardy  
   STRPTR tabdec2;                     // adres cigu ASCII liczby dziesitnej bez pierwszych zer, zakres ten sam  
   STRPTR tabhex1;                     // adres cigu ASCII liczby szesnastkowej.  
   STRPTR tabroman1;                   // adres cigu ASCII liczby rzymskiej.
   WORD _kolor0;                       // kolor 0 tekstu patrz funkcja WyswTXT
   WORD _kolor1;                       // kolor 1 tekstu patrz funkcja WyswTXT                        

   struct Window *s_WinBase;           // adres struktury Window otwartego okna na ostatnio otwartym screenie - patrz MOpenScreen()
   struct Library *GadToolsBase;       // adres bazowy biblioteki gadtools
   APTR Screen_Tags;                   // opcjonalnie adres Tagw dla nowo otwieranego ekranu - patrz MOpenScreen()
   WORD Precc;                         // wczenie 'precyzyjnej (do 1 pixela) procedury C2P
   struct Window *WindowTags;          // !Private!  (wskanik na tymczasow struktur window)
   struct Screen *ScrSTR;              // !Private!  (wskanik na tymczasow struktur Screen)
   APTR buff1;                         // !Private!  (wskanik na osiem bajtw dla C2P)


};

struct MScreen
{
   struct Window *s_Win_Base;      // adres struktury window otwartego okna backdrop
   struct Screen *s_ScreenBase;    // adres struktury screen otwartego ekranu
   struct RastPort *s_RastPort;    // adres rastportu otwartego ekranu
   struct BitMap *s_BitMap_STR;    // adres struktury bitmap otwartego ekranu
   LONG  s_BestModeTags;           // !private!
   LONG s_ScreenTags;              // !private!
   PLANEPTR s_bitplan0;            // adresy bitplanw
   PLANEPTR s_bitplan1;
   PLANEPTR s_bitplan2;
   PLANEPTR s_bitplan3;
   PLANEPTR s_bitplan4;
   PLANEPTR s_bitplan5;
   PLANEPTR s_bitplan6;
   PLANEPTR s_bitplan7;

   LONG s_ModeID;                   // tryb otwartego ekranu
   struct MsgPort *s_UserPort;      // userport okna backdrop na ekranie
   struct ViewPort *s_ViewPort;     // ViewPort otwartego ekranu
   APTR s_RasInfo;                  // RasInfo otwartego ekranu
   LONG s_Height;                   // wysoko otwartego ekranu
   LONG s_Width;                    // szeroko otwartego ekranu
   LONG s_OffSet;                   // odstp pomidzy dwoma ekranami (w trybie double buffer)
   APTR s_WindowTags;               // !private! (wskanik na tagi dla OpenWindowTagList() )

};

#endif  /* !MISTERQ_MISTERQ_H */
